Index: /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/Predictor.cs
===================================================================
--- /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/Predictor.cs	(revision 2414)
+++ /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/Predictor.cs	(revision 2415)
@@ -79,5 +79,5 @@
       Problem p = SVMHelper.CreateSVMProblem(input, input.GetVariableIndex(targetVariable), newIndex,
         start, end, minTimeOffset, maxTimeOffset);
-      Problem scaledProblem = SVM.Scaling.Scale(p, transform);
+      Problem scaledProblem = transform.Scale(p);
 
       int targetVariableIndex = input.GetVariableIndex(targetVariable);
@@ -155,4 +155,47 @@
       }
     }
+
+    public static void Export(Predictor p, Stream s) {
+      StreamWriter writer = new StreamWriter(s);
+      writer.Write("Targetvariable: "); writer.WriteLine(p.targetVariable);
+      writer.Write("LowerPredictionLimit: "); writer.WriteLine(p.LowerPredictionLimit.ToString());
+      writer.Write("UpperPredictionLimit: "); writer.WriteLine(p.UpperPredictionLimit.ToString());
+      writer.Write("MaxTimeOffset: "); writer.WriteLine(p.MaxTimeOffset.ToString());
+      writer.Write("MinTimeOffset: "); writer.WriteLine(p.MinTimeOffset.ToString());
+      writer.Write("InputVariables :");
+      writer.Write(p.GetInputVariables().First());
+      foreach (string variable in p.GetInputVariables().Skip(1)) {
+        writer.Write("; "); writer.Write(variable);
+      }
+      writer.WriteLine();
+      writer.Flush();
+      using (MemoryStream memStream = new MemoryStream()) {
+        SVMModel.Export(p.Model, memStream);
+        memStream.WriteTo(s);
+      }
+    }
+
+    public static Predictor Import(Stream s) {
+      Predictor p = new Predictor();
+      StreamReader reader = new StreamReader(s);
+      string[] targetVariableLine = reader.ReadLine().Split(':');
+      string[] lowerPredictionLimitLine = reader.ReadLine().Split(':');
+      string[] upperPredictionLimitLine = reader.ReadLine().Split(':');
+      string[] maxTimeOffsetLine = reader.ReadLine().Split(':');
+      string[] minTimeOffsetLine = reader.ReadLine().Split(':');
+      string[] inputVariableLine = reader.ReadLine().Split(':', ';');
+
+      p.targetVariable = targetVariableLine[1].Trim();
+      p.LowerPredictionLimit = double.Parse(lowerPredictionLimitLine[1]);
+      p.UpperPredictionLimit = double.Parse(upperPredictionLimitLine[1]);
+      p.maxTimeOffset = int.Parse(maxTimeOffsetLine[1]);
+      p.minTimeOffset = int.Parse(minTimeOffsetLine[1]);
+      int i = 1;
+      foreach (string inputVariable in inputVariableLine.Skip(1)) {
+        p.variableNames[inputVariable.Trim()] = i++;
+      }
+      p.svmModel = SVMModel.Import(s);
+      return p;
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/PredictorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/PredictorView.cs	(revision 2414)
+++ /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/PredictorView.cs	(revision 2415)
@@ -29,4 +29,5 @@
 using System.Windows.Forms;
 using HeuristicLab.Core;
+using System.IO;
 
 namespace HeuristicLab.SupportVectorMachines {
@@ -50,18 +51,18 @@
     }
 
-    protected override string GetModelString() {
-      StringBuilder builder = new StringBuilder();
-      builder.Append("LowerPredictionLimit: ").AppendLine(predictor.LowerPredictionLimit.ToString());
-      builder.Append("UpperPredictionLimit: ").AppendLine(predictor.UpperPredictionLimit.ToString());
-      builder.Append("MaxTimeOffset: ").AppendLine(predictor.MaxTimeOffset.ToString());
-      builder.Append("MinTimeOffset: ").AppendLine(predictor.MinTimeOffset.ToString());
-      builder.Append("InputVariables :");
-      builder.Append(predictor.GetInputVariables().First());
-      foreach (string variable in predictor.GetInputVariables().Skip(1)) {
-        builder.Append("; ").Append(variable);
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      textBox.Text = GetModelString();
+    }
+
+    private string GetModelString() {
+      if (predictor == null) return "";
+      using (MemoryStream s = new MemoryStream()) {
+        Predictor.Export(predictor, s);
+        s.Flush();
+        s.Seek(0, System.IO.SeekOrigin.Begin);
+        StreamReader reader = new StreamReader(s);
+        return reader.ReadToEnd();
       }
-      builder.AppendLine();
-      builder.Append(base.GetModelString());
-      return builder.ToString();
     }
   }
Index: /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs	(revision 2414)
+++ /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs	(revision 2415)
@@ -116,4 +116,34 @@
       }
     }
+
+    public static void Export(SVMModel model, Stream s) {
+      StreamWriter writer = new StreamWriter(s);
+      writer.WriteLine("RangeTransform:");
+      using (MemoryStream memStream = new MemoryStream()) {
+        SVM.RangeTransform.Write(memStream, model.RangeTransform);
+        memStream.Seek(0, SeekOrigin.Begin);
+        memStream.WriteTo(s);
+      }
+      writer.WriteLine("Model:");
+
+      using (MemoryStream memStream = new MemoryStream()) {
+        SVM.Model.Write(memStream, model.Model);
+        memStream.Seek(0, SeekOrigin.Begin);
+        memStream.WriteTo(s);
+      }
+      s.Flush();
+    }
+
+    public static SVMModel Import(Stream s) {
+      SVMModel model = new SVMModel();
+      StreamReader reader = new StreamReader(s);
+      while (reader.ReadLine().Trim() != "RangeTransform:") ; // read until line "RangeTransform";
+      model.RangeTransform = SVM.RangeTransform.Read(s);
+
+      // read until "Model:"
+      while (reader.ReadLine().Trim() != "Model:") ;
+      model.Model = SVM.Model.Read(s);
+      return model;
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs
===================================================================
--- /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs	(revision 2414)
+++ /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs	(revision 2415)
@@ -49,4 +49,5 @@
       kernelType.DataBindings.Add(new Binding("Text", model.Model.Parameter, "KernelType"));
       gamma.DataBindings.Add(new Binding("Text", model.Model.Parameter, "Gamma"));
+      UpdateControls();
     }
 
@@ -56,21 +57,12 @@
     }
 
-    protected virtual string GetModelString() {
-      StringBuilder builder = new StringBuilder();
-      builder.AppendLine("RangeTransform:");
-      using (MemoryStream stream = new MemoryStream()) {
-        SVM.RangeTransform.Write(stream, model.RangeTransform);
-        stream.Seek(0, System.IO.SeekOrigin.Begin);
-        StreamReader reader = new StreamReader(stream);
-        builder.AppendLine(reader.ReadToEnd());
+    private string GetModelString() {
+      using (MemoryStream s = new MemoryStream()) {
+        SVMModel.Export(model, s);
+        s.Flush();
+        s.Seek(0, System.IO.SeekOrigin.Begin);
+        StreamReader reader = new StreamReader(s);
+        return reader.ReadToEnd();
       }
-      builder.AppendLine("Model:");
-      using (MemoryStream stream = new MemoryStream()) {
-        SVM.Model.Write(stream, model.Model);
-        stream.Seek(0, System.IO.SeekOrigin.Begin);
-        StreamReader reader = new StreamReader(stream);
-        builder.AppendLine(reader.ReadToEnd());
-      }
-      return builder.ToString();
     }
   }
Index: /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorCreator.cs	(revision 2414)
+++ /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorCreator.cs	(revision 2415)
@@ -28,4 +28,5 @@
 using HeuristicLab.DataAnalysis;
 using System.Threading;
+using SVM;
 
 namespace HeuristicLab.SupportVectorMachines {
@@ -85,8 +86,10 @@
       parameter.Nu = GetVariableValue<DoubleData>("SVMNu", scope, true).Data;
       parameter.Gamma = GetVariableValue<DoubleData>("SVMGamma", scope, true).Data;
+      parameter.CacheSize = 500;
+      parameter.Probability = false;
 
       SVM.Problem problem = SVMHelper.CreateSVMProblem(dataset, targetVariable, start, end, minTimeOffset, maxTimeOffset);
-      SVM.RangeTransform rangeTransform = SVM.Scaling.DetermineRange(problem);
-      SVM.Problem scaledProblem = SVM.Scaling.Scale(problem, rangeTransform);
+      SVM.RangeTransform rangeTransform = SVM.RangeTransform.Compute(problem);
+      SVM.Problem scaledProblem = rangeTransform.Scale(problem);
 
       SVM.Model model = StartTraining(scaledProblem, parameter);
Index: /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorEvaluator.cs	(revision 2414)
+++ /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorEvaluator.cs	(revision 2415)
@@ -27,4 +27,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.DataAnalysis;
+using SVM;
 
 namespace HeuristicLab.SupportVectorMachines {
@@ -56,5 +57,5 @@
       SVMModel modelData = GetVariableValue<SVMModel>("SVMModel", scope, true);
       SVM.Problem problem = SVMHelper.CreateSVMProblem(dataset, targetVariable, start, end, minTimeOffset, maxTimeOffset);
-      SVM.Problem scaledProblem = SVM.Scaling.Scale(problem, modelData.RangeTransform);
+      SVM.Problem scaledProblem = modelData.RangeTransform.Scale(problem);
 
       double[,] values = new double[scaledProblem.Count, 2];
Index: /trunk/sources/LibSVM/Cache.cs
===================================================================
--- /trunk/sources/LibSVM/Cache.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Cache.cs	(revision 2415)
@@ -49,5 +49,5 @@
         private head_t lru_head;
 
-        internal Cache(int count, long size)
+        public Cache(int count, long size)
         {
             _count = count;
@@ -78,9 +78,16 @@
         }
 
+        private static void swap<T>(ref T lhs, ref T rhs)
+        {
+            T tmp = lhs;
+            lhs = rhs;
+            rhs = tmp;
+        }
+
         // request data [0,len)
         // return some position p where [p,len) need to be filled
         // (p >= len if nothing needs to be filled)
         // java: simulate pointer using single-element array
-        internal virtual int get_data(int index, float[][] data, int len)
+        public int GetData(int index, ref float[] data, int len)
         {
             head_t h = head[index];
@@ -107,17 +114,13 @@
                 h.data = new_data;
                 _size -= more;
-                do
-                {
-                    int _ = h.len; h.len = len; len = _;
-                }
-                while (false);
+                swap(ref h.len, ref len);
             }
 
             lru_insert(h);
-            data[0] = h.data;
+            data = h.data;
             return len;
         }
 
-        internal virtual void swap_index(int i, int j)
+        public void SwapIndex(int i, int j)
         {
             if (i == j)
@@ -128,14 +131,6 @@
             if (head[j].len > 0)
                 lru_delete(head[j]);
-            do
-            {
-                float[] _ = head[i].data; head[i].data = head[j].data; head[j].data = _;
-            }
-            while (false);
-            do
-            {
-                int _ = head[i].len; head[i].len = head[j].len; head[j].len = _;
-            }
-            while (false);
+            swap(ref head[i].data, ref head[j].data);
+            swap(ref head[i].len, ref head[j].len);
             if (head[i].len > 0)
                 lru_insert(head[i]);
@@ -144,9 +139,6 @@
 
             if (i > j)
-                do
-                {
-                    int _ = i; i = j; j = _;
-                }
-                while (false);
+                swap(ref i, ref j);
+
             for (head_t h = lru_head.next; h != lru_head; h = h.next)
             {
@@ -154,9 +146,5 @@
                 {
                     if (h.len > j)
-                        do
-                        {
-                            float _ = h.data[i]; h.data[i] = h.data[j]; h.data[j] = _;
-                        }
-                        while (false);
+                        swap(ref h.data[i], ref h.data[j]);
                     else
                     {
Index: /trunk/sources/LibSVM/GaussianTransform.cs
===================================================================
--- /trunk/sources/LibSVM/GaussianTransform.cs	(revision 2414)
+++ /trunk/sources/LibSVM/GaussianTransform.cs	(revision 2415)
@@ -21,82 +21,71 @@
 using System.Collections.Generic;
 using System.IO;
+using System.Globalization;
+using System.Threading;
 
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// A transform which learns the mean and variance of a sample set and uses these to transform new data
     /// so that it has zero mean and unit variance.
-    /// </remarks>
+    /// </summary>
     public class GaussianTransform : IRangeTransform
     {
-        private List<Node[]> _samples;
-        private int _maxIndex;
-
         private double[] _means;
         private double[] _stddevs;
 
         /// <summary>
+        /// Determines the Gaussian transform for the provided problem.
+        /// </summary>
+        /// <param name="prob">The Problem to analyze</param>
+        /// <returns>The Gaussian transform for the problem</returns>
+        public static GaussianTransform Compute(Problem prob)
+        {
+            int[] counts = new int[prob.MaxIndex];
+            double[] means = new double[prob.MaxIndex];
+            foreach (Node[] sample in prob.X)
+            {
+                for (int i = 0; i < sample.Length; i++)
+                {
+                    means[sample[i].Index-1] += sample[i].Value;
+                    counts[sample[i].Index-1]++;
+                }
+            }
+            for (int i = 0; i < prob.MaxIndex; i++)
+            {
+                if (counts[i] == 0)
+                    counts[i] = 2;
+                means[i] /= counts[i];
+            }
+
+            double[] stddevs = new double[prob.MaxIndex];
+            foreach (Node[] sample in prob.X)
+            {
+                for (int i = 0; i < sample.Length; i++)
+                {
+                    double diff = sample[i].Value - means[sample[i].Index - 1];
+                    stddevs[sample[i].Index - 1] += diff * diff;
+                }
+            }
+            for (int i = 0; i < prob.MaxIndex; i++)
+            {
+                if (stddevs[i] == 0)
+                    continue;
+                stddevs[i] /= (counts[i] - 1);
+                stddevs[i] = Math.Sqrt(stddevs[i]);
+            }
+
+            return new GaussianTransform(means, stddevs);
+        }
+
+        /// <summary>
         /// Constructor.
         /// </summary>
-        /// <param name="maxIndex">The maximum index of the vectors to be transformed</param>
-        public GaussianTransform(int maxIndex)
-        {
-            _samples = new List<Node[]>();
-        }
-        private GaussianTransform(double[] means, double[] stddevs, int maxIndex)
+        /// <param name="means">Means in each dimension</param>
+        /// <param name="stddevs">Standard deviation in each dimension</param>
+        public GaussianTransform(double[] means, double[] stddevs)
         {
             _means = means;
             _stddevs = stddevs;
-            _maxIndex = maxIndex;
-        }
-
-        /// <summary>
-        /// Adds a sample to the data.  No computation is performed.  The maximum index of the
-        /// sample must be less than MaxIndex.
-        /// </summary>
-        /// <param name="sample">The sample to add</param>
-        public void Add(Node[] sample)
-        {
-            _samples.Add(sample);
-        }
-
-        /// <summary>
-        /// Computes the statistics for the samples which have been obtained so far.
-        /// </summary>
-        public void ComputeStatistics()
-        {
-            int[] counts = new int[_maxIndex];
-            _means = new double[_maxIndex];
-            foreach(Node[] sample in _samples)
-            {
-                for (int i = 0; i < sample.Length; i++)
-                {
-                    _means[sample[i].Index] += sample[i].Value;
-                    counts[sample[i].Index]++;
-                }
-            }
-            for (int i = 0; i < _maxIndex; i++)
-            {
-                if (counts[i] == 0)
-                    counts[i] = 2;
-                _means[i] /= counts[i];
-            }
-
-            _stddevs = new double[_maxIndex];
-            foreach(Node[] sample in _samples)
-            {
-                for (int i = 0; i < sample.Length; i++)
-                {
-                    double diff = sample[i].Value - _means[sample[i].Index];
-                    _stddevs[sample[i].Index] += diff * diff;
-                }
-            }
-            for (int i = 0; i < _maxIndex; i++)
-            {
-                if (_stddevs[i] == 0)
-                    continue;
-                _stddevs[i] /= (counts[i]-1);
-                _stddevs[i] = Math.Sqrt(_stddevs[i]);
-            }
         }
 
@@ -109,9 +98,13 @@
         public static void Write(Stream stream, GaussianTransform transform)
         {
+            TemporaryCulture.Start();
+
             StreamWriter output = new StreamWriter(stream);
-            output.WriteLine(transform._maxIndex);
-            for (int i = 0; i < transform._maxIndex; i++)
+            output.WriteLine(transform._means.Length);
+            for (int i = 0; i < transform._means.Length; i++)
                 output.WriteLine("{0} {1}", transform._means[i], transform._stddevs[i]);
             output.Flush();
+
+            TemporaryCulture.Stop();
         }
 
@@ -123,6 +116,8 @@
         public static GaussianTransform Read(Stream stream)
         {
+            TemporaryCulture.Start();
+
             StreamReader input = new StreamReader(stream);
-            int length = int.Parse(input.ReadLine());
+            int length = int.Parse(input.ReadLine(), CultureInfo.InvariantCulture);
             double[] means = new double[length];
             double[] stddevs = new double[length];
@@ -130,8 +125,11 @@
             {
                 string[] parts = input.ReadLine().Split();
-                means[i] = double.Parse(parts[0]);
-                stddevs[i] = double.Parse(parts[1]);
-            }
-            return new GaussianTransform(means, stddevs, length);
+                means[i] = double.Parse(parts[0], CultureInfo.InvariantCulture);
+                stddevs[i] = double.Parse(parts[1], CultureInfo.InvariantCulture);
+            }
+
+            TemporaryCulture.Stop();
+
+            return new GaussianTransform(means, stddevs);
         }
 
@@ -177,6 +175,4 @@
         /// <summary>
         /// Transform the input value using the transform stored for the provided index.
-        /// <see cref="ComputeStatistics"/> must be called first, or the transform must
-        /// have been read from the disk.
         /// </summary>
         /// <param name="input">Input value</param>
@@ -185,4 +181,5 @@
         public double Transform(double input, int index)
         {
+            index--;
             if (_stddevs[index] == 0)
                 return 0;
@@ -192,6 +189,5 @@
         }
         /// <summary>
-        /// Transforms the input array.  <see cref="ComputeStatistics"/> must be called 
-        /// first, or the transform must have been read from the disk.
+        /// Transforms the input array.
         /// </summary>
         /// <param name="input">The array to transform</param>
Index: /trunk/sources/LibSVM/IRangeTransform.cs
===================================================================
--- /trunk/sources/LibSVM/IRangeTransform.cs	(revision 2414)
+++ /trunk/sources/LibSVM/IRangeTransform.cs	(revision 2415)
@@ -20,7 +20,7 @@
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Interface implemented by range transforms.
-    /// </remarks>
+    /// </summary>
     public interface IRangeTransform
     {
Index: /trunk/sources/LibSVM/Kernel.cs
===================================================================
--- /trunk/sources/LibSVM/Kernel.cs	(revision 2415)
+++ /trunk/sources/LibSVM/Kernel.cs	(revision 2415)
@@ -0,0 +1,226 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace SVM
+{
+    internal interface IQMatrix
+    {
+        float[] GetQ(int column, int len);
+        float[] GetQD();
+        void SwapIndex(int i, int j);
+    }
+
+    internal abstract class Kernel : IQMatrix
+    {
+        private Node[][] _x;
+        private double[] _xSquare;
+
+        private KernelType _kernelType;
+        private int _degree;
+        private double _gamma;
+        private double _coef0;
+
+        public abstract float[] GetQ(int column, int len);
+        public abstract float[] GetQD();
+
+        public virtual void SwapIndex(int i, int j)
+        {
+            _x.SwapIndex(i, j);
+
+            if (_xSquare != null)
+            {
+                _xSquare.SwapIndex(i, j);
+            }
+        }
+
+        private static double powi(double value, int times)
+        {
+            double tmp = value, ret = 1.0;
+
+            for (int t = times; t > 0; t /= 2)
+            {
+                if (t % 2 == 1) ret *= tmp;
+                tmp = tmp * tmp;
+            }
+            return ret;
+        }
+
+        public double KernelFunction(int i, int j)
+        {
+            switch (_kernelType)
+            {
+                case KernelType.LINEAR:
+                    return dot(_x[i], _x[j]);
+                case KernelType.POLY:
+                    return powi(_gamma * dot(_x[i], _x[j]) + _coef0, _degree);
+                case KernelType.RBF:
+                    return Math.Exp(-_gamma * (_xSquare[i] + _xSquare[j] - 2 * dot(_x[i], _x[j])));
+                case KernelType.SIGMOID:
+                    return Math.Tanh(_gamma * dot(_x[i], _x[j]) + _coef0);
+                case KernelType.PRECOMPUTED:
+                    return _x[i][(int)(_x[j][0].Value)].Value;
+                default:
+                    return 0;
+            }
+        }
+
+        public Kernel(int l, Node[][] x_, Parameter param)
+        {
+            _kernelType = param.KernelType;
+            _degree = param.Degree;
+            _gamma = param.Gamma;
+            _coef0 = param.Coefficient0;
+
+            _x = (Node[][])x_.Clone();
+
+            if (_kernelType == KernelType.RBF)
+            {
+                _xSquare = new double[l];
+                for (int i = 0; i < l; i++)
+                    _xSquare[i] = dot(_x[i], _x[i]);
+            }
+            else _xSquare = null;
+        }
+
+        private static double dot(Node[] xNodes, Node[] yNodes)
+        {
+            double sum = 0;
+            int xlen = xNodes.Length;
+            int ylen = yNodes.Length;
+            int i = 0;
+            int j = 0;
+            Node x = xNodes[0];
+            Node y = yNodes[0];
+            while (true)
+            {
+                if (x._index == y._index)
+                {
+                    sum += x._value * y._value;
+                    i++;
+                    j++;
+                    if (i < xlen && j < ylen)
+                    {
+                        x = xNodes[i];
+                        y = yNodes[j];
+                    }
+                    else if (i < xlen)
+                    {
+                        x = xNodes[i];
+                        break;
+                    }
+                    else if (j < ylen)
+                    {
+                        y = yNodes[j];
+                        break;
+                    }
+                    else break;
+                }
+                else
+                {
+                    if (x._index > y._index)
+                    {
+                        ++j;
+                        if (j < ylen)
+                            y = yNodes[j];
+                        else break;
+                    }
+                    else
+                    {
+                        ++i;
+                        if (i < xlen)
+                            x = xNodes[i];
+                        else break;
+                    }
+                }
+            }
+            return sum;
+        }
+
+        private static double computeSquaredDistance(Node[] xNodes, Node[] yNodes)
+        {
+            Node x = xNodes[0];
+            Node y = yNodes[0];
+            int xLength = xNodes.Length;
+            int yLength = yNodes.Length;
+            int xIndex = 0;
+            int yIndex = 0;
+            double sum = 0;
+
+            while (true)
+            {
+                if (x._index == y._index)
+                {
+                    double d = x._value - y._value;
+                    sum += d * d;
+                    xIndex++;
+                    yIndex++;
+                    if (xIndex < xLength && yIndex < yLength)
+                    {
+                        x = xNodes[xIndex];
+                        y = yNodes[yIndex];
+                    }
+                    else if(xIndex < xLength){
+                        x = xNodes[xIndex];
+                        break;
+                    }
+                    else if(yIndex < yLength){
+                        y = yNodes[yIndex];
+                        break;
+                    }else break;
+                }
+                else if (x._index > y._index)
+                {
+                    sum += y._value * y._value;
+                    if (++yIndex < yLength)
+                        y = yNodes[yIndex];
+                    else break;
+                }
+                else
+                {
+                    sum += x._value * x._value;
+                    if (++xIndex < xLength)
+                        x = xNodes[xIndex];
+                    else break;
+                }
+            }
+
+            for (; xIndex < xLength; xIndex++)
+            {
+                double d = xNodes[xIndex]._value;
+                sum += d * d;
+            }
+
+            for (; yIndex < yLength; yIndex++)
+            {
+                double d = yNodes[yIndex]._value;
+                sum += d * d;
+            }
+
+            return sum;
+        }
+
+        public static double KernelFunction(Node[] x, Node[] y, Parameter param)
+        {
+            switch (param.KernelType)
+            {
+                case KernelType.LINEAR:
+                    return dot(x, y);
+                case KernelType.POLY:
+                    return powi(param.Degree * dot(x, y) + param.Coefficient0, param.Degree);
+                case KernelType.RBF:
+                    {
+                        double sum = computeSquaredDistance(x, y);
+                        return Math.Exp(-param.Gamma * sum);
+                    }
+                case KernelType.SIGMOID:
+                    return Math.Tanh(param.Gamma * dot(x, y) + param.Coefficient0);
+                case KernelType.PRECOMPUTED:
+                    return x[(int)(y[0].Value)].Value;
+                default:
+                    return 0;
+            }
+        }
+    }
+}
Index: /trunk/sources/LibSVM/LibSVM.csproj
===================================================================
--- /trunk/sources/LibSVM/LibSVM.csproj	(revision 2414)
+++ /trunk/sources/LibSVM/LibSVM.csproj	(revision 2415)
@@ -80,4 +80,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Kernel.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Cache.cs" />
@@ -95,5 +96,6 @@
     <Compile Include="Scaling.cs" />
     <Compile Include="Solver.cs" />
-    <Compile Include="SupportClass.cs" />
+    <Compile Include="SVMExtensions.cs" />
+    <Compile Include="TemporaryCulture.cs" />
     <Compile Include="Training.cs" />
   </ItemGroup>
